/*
 * Copyright (c) 2015-2020 IMDEA Networks Institute
 * Author: Hany Assasa <hany.assasa@gmail.com>
 */

#ifndef RF_CHAIN_H
#define RF_CHAIN_H

#include "wigig-data-types.h"

#include "ns3/mac48-address.h"
#include "ns3/object.h"
#include "ns3/traced-value.h"

#include <map>

namespace ns3
{

enum SectorType
{
    TX_SECTOR = 0,
    RX_SECTOR = 1,
    TX_RX_SECTOR = 2,
}; //!< Sector Type (TX/RX/Both).

enum SectorUsage
{
    BHI_SECTOR = 0,
    SLS_SECTOR = 1,
    BHI_SLS_SECTOR = 2
}; //!< Sector usage during Beacon Interval.

enum SectorSweepType
{
    TransmitSectorSweep = 0,
    ReceiveSectorSweep = 1,
}; //!< Type of the sector level sweep (Transmit or Receive Sector Level Sweep).

enum BeamRefinementType
{
    RefineTransmitSector = 0,
    RefineReceiveSector = 1,
}; //!< Type of the Beam Refinement (Tx or Rx).

/**
 * Generic Radiation Pattern Configuration.
 */
struct PatternConfig : public SimpleRefCount<PatternConfig>
{
    virtual ~PatternConfig() = default;
};

/**
 * Generic Antenna Weight Vector (AWV) Configuration.
 */
struct AwvConfig : virtual public PatternConfig
{
};

typedef std::vector<Ptr<AwvConfig>> AWV_LIST; //<! Typedef for a list of parametric AWVs.
typedef AWV_LIST::iterator AWV_LIST_I;        //<! Typedef for a parametric AWV iterator.

/**
 * Generic Virtual Sector configuration.
 */
struct SectorConfig : virtual public PatternConfig
{
    SectorType sectorType;   //!< Type of the sector.
    SectorUsage sectorUsage; //!< Usage of the predefined sector.
    AWV_LIST awvList;        //!< List of AWVs associated with this sector.
};

typedef std::map<SectorId, Ptr<SectorConfig>>
    SectorList; //!< Typedef for vector of generic sectors generated by the phased antenna array.

/**
 * 3D orientation vector in Degrees.
 */
struct Orientation
{
    double psi;   //!< Rotation around the z-axis.
    double theta; //!< Rotation around the y-axis.
    double phi;   //!< Rotation around the x-axis.
};

class RfChain;

/**
 * Generic Phased antenna array configuration.
 */
struct PhasedAntennaArrayConfig : public SimpleRefCount<PhasedAntennaArrayConfig>
{
    PhasedAntennaArrayConfig()
        : isConnected(false)
    {
    }

    /**
     * Set the quasi-omni pattern associated with this array.
     * \param A pointer to the configuration of the quasi-omni pattern.
     */
    void SetQuasiOmniConfig(Ptr<PatternConfig> quasiPattern);
    Ptr<PatternConfig> GetQuasiOmniConfig() const;

    double azimuthOrientationDegree; //!< Azimuth Orientation degree (Phi in Spherical Coordinates).
    double elevationOrientationDegree; //!< Elevation Orientation degree (Theta in Spherical
                                       //!< Coordinates).
    Orientation orientation;           //!< Phased Antenna Array 3D orientation.
    SectorList sectorList; //!< Vector of sectors supported by this phased antenna array.
    Ptr<RfChain> rfChain;  //!< A pointer to the RF chain this array is connected to.
    bool isConnected;      //!< Flag to indicate if the Array is connected to an RF chain.

  protected:
    Ptr<PatternConfig>
        m_quasiOmniConfig; //<! Pointer to the quasi-omni pattern associated with this array.
};

typedef std::vector<SectorId> SectorIdList; //!< Typedef for a list of sectors IDs.
typedef std::map<AntennaId, SectorIdList>
    Antenna2SectorList; //!< Typedef for list of sectors per antenna array.
typedef Antenna2SectorList::iterator
    Antenna2SectorListI; //!< Typedef for iterator across antennas to sectors list.
typedef std::map<AntennaId, Ptr<PhasedAntennaArrayConfig>>
    AntennaArrayList; //!< Typedef for list of phased antenna arrays.
typedef AntennaArrayList::iterator
    AntennaArrayListI; //!< Typedef for codebook Configuration Iterator.

/**
 * Radio Frequency (RF) Chain configuration.
 *
 * In the current implementation, we assume partially connected beamforming architecture i.e. each
 * RF Chain is connected to either a single or multiple phased antenna arrays. However, only a
 * single antenna array is active within each RF chain.
 */
class RfChain : public Object
{
  public:
    static TypeId GetTypeId();

    RfChain();
    ~RfChain() override;

    /**
     * Connect a phased antenna array to this RF chain.
     * \param antennaID The ID of the antenna array to be connected to this RF chain.
     * \param array Pointer to the antenna array structure.
     */
    void ConnectPhasedAntennaArray(AntennaId antennaID, Ptr<PhasedAntennaArrayConfig> array);

    /**
     * Set the ID of the active AWV within the current transmit sector.
     * \param awvID The ID of the AWV within the transmit sector.
     */
    void SetActiveTxAwvId(AwvId awvID);
    /**
     * Set the ID of the active AWV ID within the current receive sector.
     * \param awvID The ID of the AWV within the receive sector.
     */
    void SetActiveRxAwvId(AwvId awvID);
    /**
     * Set the ID of the active transmit sector.
     * \param sectorID The ID of the transmit sector wthin the antenna array.
     */
    void SetActiveTxSectorId(SectorId sectorID);
    /**
     * Set the ID of the active receive sector.
     * \param sectorID The ID of the receive sector wthin the antenna array.
     */
    void SetActiveRxSectorId(SectorId sectorID);
    /**
     * Set the ID of the active transmit sector.
     * \param antennaID The ID of the phased antenna array.
     * \param sectorID The ID of the new sector wthin the antenna array.
     */
    void SetActiveTxSectorId(AntennaId antennaID, SectorId sectorID);
    /**
     * Set the ID of the active receive sector.
     * \param antennaID The ID of the phased antenna array.
     * \param sectorID The ID of the new sector wthin the antenna array.
     */
    void SetActiveRxSectorId(AntennaId antennaID, SectorId sectorID);

    /**
     * Get the ID of the current active AWV within the current transmit sector.
     * \return The ID of the AWV within the transmit sector.
     */
    AwvId SetActiveTxAwvId() const;
    /**
     * Get the ID of the current active AWV ID within the current receive sector.
     * \return The ID of the AWV within the receive sector.
     */
    AwvId SetActiveRxAwvId() const;
    /**
     * Get the ID of the current active Tx Sector.
     * \return the ID of the current active Tx Sector.
     */
    SectorId GetActiveTxSectorId() const;
    /**
     * Get the ID of the current active Rx Sector.
     * \return the ID of the current active Rx Sector.
     */
    SectorId GetActiveRxSectorId() const;
    /**
     * Get the ID of the current active antenna array.
     * \return the ID of the current active antenna array.
     */
    AntennaId GetActiveAntennaId() const;

    /**
     * Return the number of AWVs used by the current active Tx/Rx sector.
     * \param antennaID
     * \param sectorID
     * \return The total number of AWVs used by the current active Tx/Rx sector.
     */
    uint8_t GetNumberOfAwvs(AntennaId antennaID, SectorId sectorID) const;
    /**
     * Get active Tx pattern ID (Sector ID or AWV ID).
     * \return Active Tx pattern ID
     */
    uint8_t GetActiveTxPatternId() const;
    /**
     * Get active Rx pattern ID (Sector ID or AWV ID).
     * \return Active Rx pattern ID.
     */
    uint8_t GetActiveRxPatternId() const;
    /**
     * Get current active transmit antenna array pattern config.
     * \return A pointer to the pattern conifg of the transmit phased antenna array.
     */
    Ptr<PatternConfig> GetTxPatternConfig() const;
    /**
     * Get current active receive antenna array pattern config.
     * \return A pointer to the pattern conifg of the receive phased antenna array.
     */
    Ptr<PatternConfig> GetRxPatternConfig() const;
    /**
     * Get current active antenna array config.
     * \return A pointer to the current active antenna array config.
     */
    Ptr<PhasedAntennaArrayConfig> GetAntennaArrayConfig() const;
    /**
     * Get the next AWV in the AWV list of the selected transmit/receive sector.
     * \return True if we've tried all the AWVs, otherwise False.
     */
    bool GetNextAwv();
    /**
     * Reuse the last used transmit sector within the same antenna array.
     * This function is called after Beam Tracking or initiating Beam Refinement.
     */
    void UseLastTxSector();
    /**
     * Reuse custom AWV for communication/Beam refinement.
     * This function is called in WigigPhy during beam refinement.
     * \param type Type of Beam refinement - Transmit or Receive.
     */
    void UseCustomAwv(BeamRefinementType type);
    /**
     * Check whether we are using custom AWV for Tx or Rx.
     * \return True if we are using custom AWV, otherwise False if we are using sector.
     */
    bool IsCustomAwvUsed() const;

    /**
     * Check the current receiving mode (Quasi = True, Dierctional = False),
     * \return True if the antenna is in quasi-omni reception mode; otherwise false.
     */
    bool IsQuasiOmniMode() const;
    /**
     * Select the quasi-omni receive mode for the current phased antenna array.
     */
    void SetReceivingInQuasiOmniMode();
    /**
     * Set specific antenna pattern to quasi-omni mode.
     * \param antennaID The ID of the phased antenna array.
     */
    void SetReceivingInQuasiOmniMode(AntennaId antennaID);
    /**
     * Start receiving in Quasi-omni Mode using the antenna array with the lowest ID.
     */
    void StartReceivingInQuasiOmniMode();
    /**
     * Switch to the next quasi-omni mode.
     * \return True, if switch has been done, false otherwise.
     */
    bool SwitchToNextQuasiPattern();
    /**
     * Set specific antenna pattern to quasi-omni mode when we have multiple antennas
     * but only one of them is active at a time.
     * \param antennaID The ID of the phased antenna array.
     */
    void SetReceivingInDirectionalMode();
    /**
     * Initiate Beam Refinement Protocol after completing SLS phase.
     * \param antennaID The ID of the phased antenna array.
     * \param sectorID The ID of the sector to refine wthin the antenna array.
     * \param type Beam Refinement Type (Transmit/Receive).
     */
    void InitiateBrp(AntennaId antennaID, SectorId sectorID, BeamRefinementType type);
    /**
     * For the current sector start using different AWVs if possible.
     * Used in when we are training using TRN-R fields appended to DMG Beacons.
     */
    void StartSectorRefinement();
    /**
     * Get number of remaining AWVs in current sector.
     * \return The total number of remaining AWVs in the current sector.
     */
    uint8_t GetRemainingAwvCount() const;

    /**
     * Reset RF chain settings including the active antenna ID and sector ID.
     */
    void Reset();

  protected:
    void DoInitialize() override;

  private:
    /**
     * Set the ID of the active antenna array.
     * \param antennaID The ID of the antenna array within the device.
     */
    void SetActiveAntennaId(AntennaId antennaID);

    AntennaArrayList
        m_antennaArrayList; //!< List of phased antenna arrays connected to this RF Chain.
    TracedValue<AntennaId> m_antennaId; //!< The ID of the current active phased antenna array.
    TracedValue<SectorId> m_txSectorId; //!< The ID of the current active transmit sector.
    TracedValue<SectorId> m_rxSectorId; //!< The ID of the current active receive sector.
    Ptr<PhasedAntennaArrayConfig> m_antennaConfig; //!< Pointer to the current active antenna array.
    Ptr<PatternConfig>
        m_txPattern; //!< Pointer to the current transmit configuration either sector or custom AWV.
    Ptr<PatternConfig>
        m_rxPattern; //!< Pointer to the current receive configuration either sector or custom AWV.

    /* Beam Refinement and Tracking Variables */
    bool m_useAwv; //!< Flag to indicate if we are using custom AWV for communication.
    BeamRefinementType
        m_beamRefinementType;   //!< Beam Refinement type during BRP Phase (Transmit/Receive).
    AWV_LIST* m_currentAwvList; //!< The current AWV List to iterate through during BRP.
    AWV_LIST_I m_currentAwvI;   //!< An iterator for the current AWV list.
    uint8_t m_remainingAwvs;    //!< The number of remaining AWVs in the current list.

    /* Quasi-omni Information */
    bool m_quasiOmniMode; //!< Flag to indicate if we receive in quasi-omni mode in the current
                          //!< receive antenna.
    AntennaArrayListI
        m_quasiAntennaIter; //!< An iterator to the current Antenna Array in Quasi Omni Mode.
};

} // namespace ns3

#endif /* RF_CHAIN_H */
